//<c>   Copyright 1990-2000 by Gerry J. Danen; all rights reserved.

//<t>   Change empty lines to have a single space

//      This program converts null lines to single space lines.  Other lines
//      have trailing spaces trimmed.  Useful for uploading messages to a BBS.
//
//              Usage:  ADDSPACE file_in file_out
//
//      Full pathnames are supported for the filenames.

#include"gd_tools.h"


#define pgVERS_ "V2.20"
#define pgTITL_ "Add a Space to Empty Lines"
#define pgCOPR_ "1990"


FILE    *iFh, *oFh ;
UCHAR   iFile[FS_LEN], oFile[FS_LEN], work[10241] ;
long    lines = 0 ;


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 3 )
    {
        fprintf( stderr, "\n\nUsage:  %s file_in file_out\n\n", get_global_program_name() );
        exit( 1 );
    }

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        exit( 2 );
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

    fprintf( stderr, "%s: processing %s ...", get_global_program_name(), iFile );

    for (;;)
    {
        if ( fgets( work, (sizeof(work)-1), iFh ) )
        {
            st_rtrim( work );
            if ( strlen(work) )
                fprintf( oFh, "%s\n", work );
            else
                fprintf( oFh, " \n" );
            lines += 1 ;
        }
        if ( feof(iFh) )
        {
            _fcloseall();
            fprintf( stderr, " %ld lines\n", lines );
            exit( 0 );
        }
    }
}
